//インポート
import gameCanvasUtil.*;
import debugger.*;

/** ゲームクラス。
 *
 * 学生が編集すべきソースコードです。
 */
public class game extends gameBase
{
    /********* 変数定義はこちらに *********/
    // 型 変数名;　の順に書いて定義する
    // ボールのX座標
    int ball_x;
    // ボールのY座標
    int ball_y;
    // ボールのX方向の速度
    int ball_speed_x;
    // ボールのY方向の速度
    int ball_speed_y;
    // ラケットのX座標
    int racket_x;
    // ラケットのY座標
    int racket_y;
    // ラケットの幅
    int racket_w;
    // ラケットの高さ
    int racket_h;

    // ゲームの状態
    int gameState;

    // ボールが画面の下を越えた回数。
    int ball_dead_num;
    // ボールがラケットに当たった回数
    int ball_hit_num;

    /********* 初期化の手順はこちらに *********/
    public void initGame()
    {
        // ボールの座標を初期化する
        ball_x = 0;
        ball_y = 100;

        // ボールの速度を初期化する
        ball_speed_x = 5;
        ball_speed_y = 5;

        // ラケットの座標を初期化する
        racket_x = 270;
        racket_y = 450;

        // ラケットの幅・高さを初期化する
        racket_w = 50;
        racket_h = 10;

        // ゲームの状態を初期化

        // ボールが画面の下を越えた回数を初期化

        // ボールがラケットに当たった回数を初期化
    }

    /********* 物体の移動等の更新処理はこちらに *********/
    public void updateGame()
    {
        // タイトル画面
        if()
        {
            // Enterキーが押されたらゲーム開始
            if()
            {
                // ゲーム画面に状態を変更
                
                // ゲーム開始なので、ゲーム画面の音楽を鳴らす
            }
        }
        // ゲーム画面
        else if()
        {
            // ENTERキーが押されたらポーズ
            if()
            {
                // ポーズ画面に状態を変更

                // ポーズ中は曲を停止
            }

            // 左キーが押され続けている場合に真
            if(gc.isKeyPress(gc.KEY_LEFT))
            {
                // ラケットを左に動かす
                racket_x = racket_x - 5;
            }
            // 右キーが押され続けている場合に真
            if(gc.isKeyPress(gc.KEY_RIGHT))
            {
                // ラケットを右に動かす
                racket_x = racket_x + 5;
            }

            // Y方向に ball_speed_y ずつ進める
            ball_y = ball_y + ball_speed_y;

            // X方向に ball_speed_x ずつ進める
            ball_x = ball_x + ball_speed_x;

            // ボールが画面の上を越えた場合
            if(ball_y < 0)
            {
                // ボールのY方向の速度を反転させる
                ball_speed_y = -ball_speed_y;
            }

            // ボールが画面の右を越えるか、画面の左を越えた場合
            if(ball_x > 616 || ball_x < 0)
            {
                // ボールのX方向の速度を反転させる
                ball_speed_x = -ball_speed_x;
            }

            // ボールが画面の下を越えた場合
            if()
            {
                // 画面の下を越えた回数を加算

                // もし、画面の下を越えた回数が 3 回以上だったら
                if()
                {
                    // ゲームオーバーにする

                    // 曲を停止
                }
                // そうでない場合、最初からゲーム再開なので、ボールの位置やラケットの位置などを最初の状態に戻す
                else
                {
                    // ボールの座標を戻す

                    // ラケットの座標を戻す

                    // ゲームの状態を戻す

                    // ボールがラケットに当たった回数を戻す
                }
            }

            // ボールと、ラケットが当たった場合に真
            if(gc.checkHitRect(racket_x, racket_y, racket_w, racket_h, ball_x, ball_y, 24, 24))
            {
                // ボールのY方向の速度を反転させる
                ball_speed_y = -ball_speed_y;

                // ラケットに当たったので、効果音を再生する

                // ラケットに当たった回数を加算

                // もし、ラケットに 5 回以上当たっていたら
                if()
                {
                    // クリアー画面へ

                    // 曲を停止
                }
            }
        }
        // ポーズ画面
        else if()
        {
            // Enterキーが押されたらゲーム再開
            if()
            {
                // ゲーム画面に状態を変更

                // ゲーム開始なので、再び曲を再生
            }
        }
        // ゲームオーバー画面
        else if()
        {
        }
        // クリアー画面
        else if()
        {
        }
    }

    /********* 画像の描画はこちらに *********/
    public void drawGame()
    {
        // 画面を白で塗りつぶします
        gc.clearScreen();

        // タイトル画面
        if()
        {
            // タイトル画面の文字を描画
            gc.setColor(0, 0, 0);
            gc.drawString("テニスゲーム", 250, 150);
            gc.drawString("Push Enter" , 260, 250);
        }
        // ゲーム画面
        else if()
        {
            // img0.png を(ball_x, ball_y)に描画します
            gc.drawImage(0, ball_x, ball_y);
            
            // 色を青にセットします
            gc.setColor(0, 0, 255);
            // ラケットを描画します
            gc.fillRect(racket_x, racket_y, racket_w, racket_h);
        }
        // ポーズ画面
        else if()
        {
            // ポーズ画面の文字を描画
            gc.setColor(0, 0, 0);
            gc.drawString("PAUSE", 280, 200);
        }
        // ゲームオーバー画面
        else if()
        {
            // ゲームオーバー画面の文字を描画
            gc.setColor(0, 0, 0);
            gc.drawString("GAME OVER", 230, 200);
        }
        // クリアー画面
        else if()
        {
            // クリアー画面の文字を描画
            gc.setColor(0, 0, 0);
            gc.drawString("CLEAR", 280, 200);
        }
    }

    /********* 終了時の処理はこちらに *********/
    public void finalGame() {}
}
